searchData={"items":[{"type":"module","title":"VintageNetWizard","doc":"Documentation for VintageNetWizard.","ref":"VintageNetWizard.html"},{"type":"function","title":"VintageNetWizard.run_if_unconfigured/1","doc":"Conditionally run the wizard if there is no configurations present\n\nThis function is the same `VintageNetWizard.run_wizard/1` however it will\nfirst check if there are any configurations for the interface.\n\nThis is useful if you want a device to start the wizard only if there are no\nconfigurations for the interface. When there are configurations found for the\ninterface this function returns `:configured` to let the consuming application\nknow that the wizard wasn't needed.\n\nIf you want more control on how to start the wizard or if you want to force\nstart the wizard you can call `VintageNetWizard.run_wizard/1`.","ref":"VintageNetWizard.html#run_if_unconfigured/1"},{"type":"function","title":"VintageNetWizard.run_wizard/1","doc":"Run the wizard.\n\nThis means the WiFi module will be put into access point mode and the web\nserver will be started.\n\nOptions:\n\n  * `:backend` - Implementation for communicating with the network drivers (defaults to `VintageNetWizard.Backend.Default`)\n  * `:captive_portal` - Whether to run in captive portal mode (defaults to `true`)\n  * `:device_info` - A list of string tuples to render in a table in the footer (see `README.md`)\n  * `:ifname` - The network interface to use (defaults to `\"wlan0\"`)\n  * `:ap_ifname` - The network interface to use to run the endpoint. Defaults to the value of `ifname`.\n  * `:inactivity_timeout` - Minutes to run before automatically stopping (defaults to 10 minutes) or `:infinity` to disable the timeout\n  * `:on_exit` - `{module, function, args}` tuple specifying callback to perform after stopping the server.\n  * `:ssl` - A Keyword list of `:ssl.tls_server_options`. See `Plug.SSL.configure/1`.\n  * `:ui` - a subset of UI configuration for title, title color, and button color.","ref":"VintageNetWizard.html#run_wizard/1"},{"type":"function","title":"VintageNetWizard.stop_wizard/1","doc":"Stop the wizard.\n\nThis will apply the current configuration in memory and completely\nstop the web and backend processes.","ref":"VintageNetWizard.html#stop_wizard/1"},{"type":"function","title":"VintageNetWizard.wifi_configured?/1","doc":"Check if an interface has a configuration","ref":"VintageNetWizard.html#wifi_configured?/1"},{"type":"type","title":"VintageNetWizard.stop_reason/0","doc":"","ref":"VintageNetWizard.html#t:stop_reason/0"},{"type":"module","title":"VintageNetWizard.APMode","doc":"This module contains utilities for configuration VintageNet in AP Mode","ref":"VintageNetWizard.APMode.html"},{"type":"function","title":"VintageNetWizard.APMode.ap_mode_configuration/3","doc":"Return a configuration to put VintageNet into AP mode\n\n* `hostname` - the device's hostname which will be modified to be the AP's SSID\n* `our_name` - the name for clients to use when connecting to the wizard if\n               not using the IP address.\n* `class_c_subnet` - A class C subnet to use for all of the IP addresses on\n               this network.","ref":"VintageNetWizard.APMode.html#ap_mode_configuration/3"},{"type":"function","title":"VintageNetWizard.APMode.exit_ap_mode/2","doc":"Change the WIFi module to exit AP mode and apply the wifi configs.","ref":"VintageNetWizard.APMode.html#exit_ap_mode/2"},{"type":"function","title":"VintageNetWizard.APMode.into_ap_mode/1","doc":"Change the WiFi module into access point mode","ref":"VintageNetWizard.APMode.html#into_ap_mode/1"},{"type":"function","title":"VintageNetWizard.APMode.ssid/0","doc":"Return SSID that is used for AP Mode","ref":"VintageNetWizard.APMode.html#ssid/0"},{"type":"behaviour","title":"VintageNetWizard.Backend","doc":"Backends define the boundaries of getting access points, handling incoming\nmessages, and scanning the network","ref":"VintageNetWizard.Backend.html"},{"type":"callback","title":"VintageNetWizard.Backend.access_points/1","doc":"Get all the access points that the backend knowns about","ref":"VintageNetWizard.Backend.html#c:access_points/1"},{"type":"callback","title":"VintageNetWizard.Backend.apply/2","doc":"Apply the WiFi configurations\n\nThe configurations passed are network configurations that can be passed into\nthe `:network` list in a `VintageNetWiFi` configuration.","ref":"VintageNetWizard.Backend.html#c:apply/2"},{"type":"callback","title":"VintageNetWizard.Backend.complete/2","doc":"Perform final completion steps for the network configurations","ref":"VintageNetWizard.Backend.html#c:complete/2"},{"type":"callback","title":"VintageNetWizard.Backend.configuration_status/1","doc":"Return the configuration status of a configuration that has been applied","ref":"VintageNetWizard.Backend.html#c:configuration_status/1"},{"type":"callback","title":"VintageNetWizard.Backend.handle_info/2","doc":"Handle any message the is received by another process\n\nIf you want the socket to send data to the client\nreturn `{:reply, message, state}`, otherwise return\n`{:noreply, state}`","ref":"VintageNetWizard.Backend.html#c:handle_info/2"},{"type":"callback","title":"VintageNetWizard.Backend.init/2","doc":"Do any initialization work like subscribing to messages\n\nWill be passed the interface names that the backend should use to scan and to set AP mode. By default\nboth will be `\"wlan0\"`. If you want to use different interface names you\ncan pass them in as options to `VintageNetWizard.run_wizard/1`.","ref":"VintageNetWizard.Backend.html#c:init/2"},{"type":"callback","title":"VintageNetWizard.Backend.reset/1","doc":"Apply any actions required to set the backend back to an\ninitial default state","ref":"VintageNetWizard.Backend.html#c:reset/1"},{"type":"callback","title":"VintageNetWizard.Backend.start_scan/1","doc":"Start scanning for WiFi access points","ref":"VintageNetWizard.Backend.html#c:start_scan/1"},{"type":"callback","title":"VintageNetWizard.Backend.stop_scan/1","doc":"Stop the scan for WiFi access points","ref":"VintageNetWizard.Backend.html#c:stop_scan/1"},{"type":"type","title":"VintageNetWizard.Backend.configuration_status/0","doc":"","ref":"VintageNetWizard.Backend.html#t:configuration_status/0"},{"type":"type","title":"VintageNetWizard.Backend.device_info_name/0","doc":"","ref":"VintageNetWizard.Backend.html#t:device_info_name/0"},{"type":"type","title":"VintageNetWizard.Backend.device_info_value/0","doc":"","ref":"VintageNetWizard.Backend.html#t:device_info_value/0"},{"type":"type","title":"VintageNetWizard.Backend.opt/0","doc":"","ref":"VintageNetWizard.Backend.html#t:opt/0"},{"type":"module","title":"VintageNetWizard.Backend.Default","doc":"The default backend implementation for target devices\n\nThis backend will be used if no other backend is configured in the\napplication configuration.","ref":"VintageNetWizard.Backend.Default.html"},{"type":"module","title":"VintageNetWizard.Backend.Mock","doc":"A default backend for host machines.\n\nThis is useful for testing and local JavaScript development.","ref":"VintageNetWizard.Backend.Mock.html"},{"type":"module","title":"VintageNetWizard.BackendServer","doc":"Server for managing a VintageNet.Backend implementation","ref":"VintageNetWizard.BackendServer.html"},{"type":"function","title":"VintageNetWizard.BackendServer.access_points/0","doc":"List out access points","ref":"VintageNetWizard.BackendServer.html#access_points/0"},{"type":"function","title":"VintageNetWizard.BackendServer.apply/0","doc":"Apply the configurations saved in the backend to\nthe system.","ref":"VintageNetWizard.BackendServer.html#apply/0"},{"type":"function","title":"VintageNetWizard.BackendServer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"VintageNetWizard.BackendServer.html#child_spec/1"},{"type":"function","title":"VintageNetWizard.BackendServer.child_spec/3","doc":"","ref":"VintageNetWizard.BackendServer.html#child_spec/3"},{"type":"function","title":"VintageNetWizard.BackendServer.complete/0","doc":"","ref":"VintageNetWizard.BackendServer.html#complete/0"},{"type":"function","title":"VintageNetWizard.BackendServer.configuration_state/0","doc":"Get the current state of the WiFi configuration","ref":"VintageNetWizard.BackendServer.html#configuration_state/0"},{"type":"function","title":"VintageNetWizard.BackendServer.configuration_status/0","doc":"Get the current configuration status","ref":"VintageNetWizard.BackendServer.html#configuration_status/0"},{"type":"function","title":"VintageNetWizard.BackendServer.configurations/0","doc":"Get a list of the current configurations","ref":"VintageNetWizard.BackendServer.html#configurations/0"},{"type":"function","title":"VintageNetWizard.BackendServer.delete_configuration/1","doc":"Delete the configuration by `ssid`","ref":"VintageNetWizard.BackendServer.html#delete_configuration/1"},{"type":"function","title":"VintageNetWizard.BackendServer.device_info/0","doc":"Return information about the device for the web page's footer","ref":"VintageNetWizard.BackendServer.html#device_info/0"},{"type":"function","title":"VintageNetWizard.BackendServer.reset/0","doc":"Reset the backend to an initial default state.","ref":"VintageNetWizard.BackendServer.html#reset/0"},{"type":"function","title":"VintageNetWizard.BackendServer.save/1","doc":"Save a network configuration to the backend\n\nThe network configuration is a map that can be included in the `:network`\nfield of a `VintageNetWiFi` configuration.","ref":"VintageNetWizard.BackendServer.html#save/1"},{"type":"function","title":"VintageNetWizard.BackendServer.set_priority_order/1","doc":"Pass list of SSIDs (`priority_order`), sort the configurations\nto match that order.","ref":"VintageNetWizard.BackendServer.html#set_priority_order/1"},{"type":"function","title":"VintageNetWizard.BackendServer.start_link/3","doc":"","ref":"VintageNetWizard.BackendServer.html#start_link/3"},{"type":"function","title":"VintageNetWizard.BackendServer.start_scan/0","doc":"Start scanning for WiFi access points","ref":"VintageNetWizard.BackendServer.html#start_scan/0"},{"type":"function","title":"VintageNetWizard.BackendServer.stop_scan/0","doc":"Stop scanning for WiFi access points","ref":"VintageNetWizard.BackendServer.html#stop_scan/0"},{"type":"function","title":"VintageNetWizard.BackendServer.subscribe/0","doc":"Subscribe to messages from the backend","ref":"VintageNetWizard.BackendServer.html#subscribe/0"},{"type":"module","title":"VintageNetWizard.Web.Endpoint","doc":"Supervisor for the Web part of the VintageNet Wizard.","ref":"VintageNetWizard.Web.Endpoint.html"},{"type":"function","title":"VintageNetWizard.Web.Endpoint.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"VintageNetWizard.Web.Endpoint.html#child_spec/1"},{"type":"function","title":"VintageNetWizard.Web.Endpoint.start_server/1","doc":"Start the web server\n\nIf the web server is started then `{:error, already_started}` is returned.\n\nOnly one server can be running at a time.","ref":"VintageNetWizard.Web.Endpoint.html#start_server/1"},{"type":"function","title":"VintageNetWizard.Web.Endpoint.stop_server/1","doc":"Stop the web server","ref":"VintageNetWizard.Web.Endpoint.html#stop_server/1"},{"type":"type","title":"VintageNetWizard.Web.Endpoint.opt/0","doc":"","ref":"VintageNetWizard.Web.Endpoint.html#t:opt/0"},{"type":"type","title":"VintageNetWizard.Web.Endpoint.ui_opt/0","doc":"UI specific configuration\n\n* `:title` - the title of the HTML pages that will be displayed to the user.\n* `:title_color` - color of the title for branding purposes\n* `:button_color` - color of the buttons for branding purposes","ref":"VintageNetWizard.Web.Endpoint.html#t:ui_opt/0"},{"type":"module","title":"VintageNetWizard.WiFiConfiguration","doc":"Module for working with various WiFi configurations","ref":"VintageNetWizard.WiFiConfiguration.html"},{"type":"function","title":"VintageNetWizard.WiFiConfiguration.get_key_mgmt/1","doc":"Get the `key_mgmt` type from the particular WiFi Configuration","ref":"VintageNetWizard.WiFiConfiguration.html#get_key_mgmt/1"},{"type":"function","title":"VintageNetWizard.WiFiConfiguration.json_to_network_config/1","doc":"Make a network config from a JSON request from the `VintageNetWizard` client","ref":"VintageNetWizard.WiFiConfiguration.html#json_to_network_config/1"},{"type":"function","title":"VintageNetWizard.WiFiConfiguration.key_mgmt_from_string/1","doc":"Convert a key_mgmt string into a key_mgmt","ref":"VintageNetWizard.WiFiConfiguration.html#key_mgmt_from_string/1"},{"type":"function","title":"VintageNetWizard.WiFiConfiguration.security_name/1","doc":"Get a human friendly name for the type of security of a WiFiConfiguration","ref":"VintageNetWizard.WiFiConfiguration.html#security_name/1"},{"type":"function","title":"VintageNetWizard.WiFiConfiguration.timeout/1","doc":"Get the expected timeout in milisecs for a particular configuration","ref":"VintageNetWizard.WiFiConfiguration.html#timeout/1"},{"type":"type","title":"VintageNetWizard.WiFiConfiguration.key_mgmt/0","doc":"","ref":"VintageNetWizard.WiFiConfiguration.html#t:key_mgmt/0"},{"type":"extras","title":"VintageNet WiFi Configuration Wizard","doc":"# VintageNet WiFi Configuration Wizard\n\n[![CircleCI](https://circleci.com/gh/nerves-networking/vintage_net_wizard.svg?style=svg)](https://circleci.com/gh/nerves-networking/vintage_net_wizard)\n[![Coverage Status](https://coveralls.io/repos/github/nerves-networking/vintage_net_wizard/badge.svg?branch=master)](https://coveralls.io/github/nerves-networking/vintage_net_wizard?branch=master)\n[![Hex version](https://img.shields.io/hexpm/v/vintage_net_wizard.svg \"Hex version\")](https://hex.pm/packages/vintage_net_wizard)\n\nThis is a WiFi configuration wizard that uses\n[VintageNet](https://github.com/nerves-networking/vintage_net). It is intended\nfor use in Nerves-based devices that don't have a display for configuring WiFi.\n\nHere's the intended use:\n\n1. On device initialization, if WiFi hasn't been configured, configure WiFi to\n   AP mode and start a webserver\n2. A user connects to the access point and opens a web browser. The only\n   website they can go to in the configuration utility.\n3. The configuration utility shows a list of access points and the user can\n   select one or more or enter information for a hidden access point\n4. The user applies the configuration and the device stops AP mode and connects\n   to the access point.\n\n`VintageNet` persists WiFi configuration so the device will be able to connect\nafter reboots and power outages. To change the configuration later, a user needs\nto take a device-specific action like hold down a button for 5 seconds. This\nlibrary has an example project for the Raspberry Pi for use as a demo.\n\n![see it in action](assets/vintage_net_wizard.gif)","ref":"readme.html"},{"type":"extras","title":"Features - VintageNet WiFi Configuration Wizard","doc":"* [x] - Simple web-based configuration utility\n* [x] - WiFi scanning while in AP mode\n* [x] - JSON REST-based API to support smartphone app-based configuration\n* [x] - Captive portal detection\n* [x] - WPA PSK configuration\n* [ ] - WPA EAP configuration\n* [x] - Hidden AP configuration\n* [x] - Multiple AP selection (device tries access points in order until one\n  works)\n* [ ] - Custom styling and branding","ref":"readme.html#features"},{"type":"extras","title":"Supported WiFi adapters - VintageNet WiFi Configuration Wizard","doc":"Not all WiFi adapters support AP mode. Here are the ones that we've used:\n\n1. Raspberry Pis with built-in WiFi modules (like the RPi 3, 4 and Zero W)\n2. RT5370-based USB modules\n3. Edimax EW-7612UAn V2 (See note)\n\nIt is highly likely that other modules work. We have not had any luck with\nother Realtek RTL8192c (in the popular Edimax EW7811Un) or MediaTek MT7601u (in\nlots of brands).\n\nNOTE: For the Edimax EW-7612UAn V2 to work, you'll need to create a custom\nNerves system with `CONFIG_RTL8192CU=m` in the `linux-x.xx.defconfig` as well as\n`BR2_PACKAGE_LINUX_FIRMWARE=y` and `BR2_PACKAGE_LINUX_FIRMWARE_RTL_81XX=y` in\n`nerves_defconfig`.","ref":"readme.html#supported-wifi-adapters"},{"type":"extras","title":"Configuration - VintageNet WiFi Configuration Wizard","doc":"It is expected that you're using\n[`VintageNet`](https://github.com/nerves-networking/vintage_net) already. If\nyou're not, see that project first.\n\n`VintageNetWizard` is an OTP application so it's mostly self-contained. Add it\nto your `mix` dependencies like so:\n\n```elixir\n   {:vintage_net_wizard, \"~> 0.4\"}\n```\n\nThe configuration wizard is not started by default to allow for more control\nover business specific situations. You will need to add a call in your code\nwhen you want the device placed into AP mode and the wizard started:\n\n```elixir\ndefmodule MyApp do\n  use Application\n\n  def start(_type, _args) do\n    if should_start_wizard?() do\n      VintageNetWizard.run_wizard\n    end\n    # ...\n    Supervisor.start_link(children, opts)\n  end\nend\n```\n\nThis will be sufficient to try it out on a device that hasn't been configured\nyet. You will want to add a mechanism for forcing the wizard the run WiFi\nconfiguration again, such as holding a button for 5+ seconds. Take a look at\n[Running the example](#running-the-example) section for steps on setting up\na button and running a quick example firmware on a device.\n\n#","ref":"readme.html#configuration"},{"type":"extras","title":"UI Customization - VintageNet WiFi Configuration Wizard","doc":"`VintageNetWizard` allows you to add customization to the UI. The three UI\nitems that can be customized are: `:title`, `:title_color`, and\n`:button_color`.\n\n```elixir\nVintageNetWizard.run_wizard(\n  ui: [title: \"My WiFi Wizard\", title_color: \"red\", button_color: \"#F0F0AD\"]\n)\n```\n\nEach configuration option is optional and will fall back to\n`VintageNetWizard`s default colors and title.\n\n#","ref":"readme.html#ui-customization"},{"type":"extras","title":"DNS in AP-mode - VintageNet WiFi Configuration Wizard","doc":"When the wizard is running, users go to either `http://192.168.0.1/` or\n`http://wifi.config/` to access the web user interface. Both can be\nchanged via the `config.exs`:\n\n```elixir\nconfig :vintage_net_wizard,\n  dns_name: \"my-wifi-config.com\",\n  subnet: \"192.168.0.0\"\n```\n\n#","ref":"readme.html#dns-in-ap-mode"},{"type":"extras","title":"Port - VintageNet WiFi Configuration Wizard","doc":"`VintageNetWizard` starts a webserver on port `80` by default. If port `80` is\nnot available on your device or you would prefer a different port, add the\nfollowing to your `config.exs`:\n\n```elixir\nconfig :vintage_net_wizard,\n  port: 4001\n```\n\nIf SSL is enabled the default port is `443`.\n\n#","ref":"readme.html#port"},{"type":"extras","title":"SSL - VintageNet WiFi Configuration Wizard","doc":"To use SSL with the web UI, you can pass SSL options to\n`VintageNetWizard.run_wizard/1`:\n\n```elixir\nVintageNetWizard.run_wizard(ssl: [keyfile: \"/path/to/key.pem\", certfile: \"/path/to/cert.pem\"])\n```\n\nTo see all available options see `Plug.SSL.configure/1` and Erlang's `:ssl`\nmodule.\n\n#","ref":"readme.html#ssl"},{"type":"extras","title":"Device Info - VintageNet WiFi Configuration Wizard","doc":"If you want to display extra data about the device in the footer of the UI you\ncan pass in a list of key-value pairs to `VintageNetWizard.run_wizard/1`:\n\n```elixir\nVintageNetWizard.run_wizard(device_info: [{\"Serial number\", \"1234\"}, {\"Version\", \"0.1.0\"}])\n```\n\nThe first item in the key-value pair is display name of the info and the second\nitem will be the value of the item.\n\n#","ref":"readme.html#device-info"},{"type":"extras","title":"Interface name - VintageNet WiFi Configuration Wizard","doc":"VintageNetWizard uses `\"wlan0\"` by default. If you have more than one wireless\nLAN or the interface is called something else, pass the appropriate interface\nname to `VintageNetWizard.run_wizard/1` to use it:\n\n```elixir\nVintageNetWizard.run_wizard(ifname: \"wlan1\")\n```\n\n#","ref":"readme.html#interface-name"},{"type":"extras","title":"Backends - VintageNet WiFi Configuration Wizard","doc":"Backends control how `VintageNetWizard` configures the network. The default\nbackend changes the network configuration as you would expect. This can get in\nthe way of development and can be disabled by using the\n`VintageNetWizard.Backend.Mock` backend:\n\n```elixir\nconfig :vintage_net_wizard,\n  backend: VintageNetWizard.Backend.Mock\n```\n\n#","ref":"readme.html#backends"},{"type":"extras","title":"Captive Portal - VintageNet WiFi Configuration Wizard","doc":"Captive portal is enabled by default. If using a port other than `80` then all\ntraffic on port `80` will be captured and redirected to the specified wizard\naddress in order to trigger the portal.\n\nYou can disable captive portal in your configuration:\n\n```elixir\nconfig :vintage_net_wizard, captive_portal: false\n```\n\n#","ref":"readme.html#captive-portal"},{"type":"extras","title":"Inactivity Timeout - VintageNet WiFi Configuration Wizard","doc":"After a set mount of time of inactivity the wizard will timeout and shut down\nthe server. This prevents a device using the wizard to infinitely be in AP mode.\nThe default timeout is 10 minutes, but can be configured:\n\n```elixir\nconfig :vintage_net_wizard,\n  inactivity_timeout:  \n```\n\nThe timeout can also be explicitly disabled by supplying `:infinity`:\n\n```elixir\nconfig :vintage_net_wizard,\n  inactivity_timeout: :infinity\n```","ref":"readme.html#inactivity-timeout"},{"type":"extras","title":"JSON API - VintageNet WiFi Configuration Wizard","doc":"It is possible to write a smartphone app to configure your device using an API\nendpoint. Documentation for the API is in [json-api.md](json-api.md).","ref":"readme.html#json-api"},{"type":"extras","title":"Running the example - VintageNet WiFi Configuration Wizard","doc":"The example builds a Nerves firmware image for supported Nerves devices\n that demonstrates the wizard. The wizard will run on\nthe first boot and also after a button has been held down for 5 seconds.\n\nFor the button to work, you'll need to wire up a button to GPIO 17/pin 11 and\n3v3/pin 1 on the Raspberry Pi's GPIO header. See the image below for the\nlocation:\n\n[![Raspberry Pi Pinout from pinout.xyz](assets/pinout-xyz.png)](https://pinout.xyz/#)\n\nIf you don't have a button, you can use a jumper wire to temporarily connect 3v3\npower to pin 11. If you have a Raspberry Pi hat with a button connected to a\ndifferent GPIO pin, you can specify with pin to use in your config:\n\n```elixir\nconfig :wizard_example, gpio_pin: 27\n```\n\nThe next step is to build the firmware. Make sure that you've installed Nerves\nand run the following:\n\n```sh\ncd example\n\n# Set the target to rpi0, rpi3, or rpi4 depending on what you have\nexport MIX_TARGET=rpi3\nmix deps.get\nmix firmware\n\n# Insert a MicroSD card or whatever media your board takes\nmix burn\n```\n\nPlace the MicroSD card in the Raspberry Pi and power it on. You should see a\nWiFi access point appear with the SSID \"nerves-1234\" where \"1234\" are part of\nthe device's serial number. Connect to the access point and then point your web\nbrowser at [http://wifi.config](http://wifi.config/) or\n[http://192.168.0.1/](http://192.168.0.1/). If you've configured an SSL\ncertificate, it's possible to use `https`. You may also need to change the\n`:dns_name` configuration to match the name on your SSL certificate.\n\nThe SSID defaults to the hostname of the device, and you can change the SSID via\nthe `config.exs`:\n\n```elixir\nconfig :vintage_net_wizard,\n  ssid: \"MY_SSID\"\n```","ref":"readme.html#running-the-example"},{"type":"extras","title":"Stop callback - VintageNet WiFi Configuration Wizard","doc":"If your application runs a webserver or has other functionality that is\nincompatible with the wizard, you can use the `:on_exit` option to\n`VintageNetWizard.run_wizard/1` to register a completion callback. The callback\nhas the form, `{module, function, args}`. Here's an example:\n\n```elixir\ndefmodule MyApp do\n  def start_wizard() do\n    VintageNetWizard.run_wizard(\n      on_exit: {__MODULE__, :handle_on_exit, []}\n    )\n  end\n\n  def handle_on_exit() do\n    Logger.info(\"VintageNetWizard stopped\")\n  end\nend\n```","ref":"readme.html#stop-callback"},{"type":"extras","title":"Development - VintageNet WiFi Configuration Wizard","doc":"It's possible to work on the wizard locally and without using Nerves or changing\nthe network settings of your development machine:\n\n```sh\n$ mix deps.get\n$ iex -S mix\n\niex> VintageNetWizard.run_wizard\n\n07:49:00.710 [info]  Go to http://localhost:4001/\n:ok\n```\n\nLook in `lib/vintage_net_wizard/backend/mock.ex` if you need to change anything\nfor your testing.","ref":"readme.html#development"},{"type":"extras","title":"JSON API","doc":"# JSON API","ref":"json-api.html"},{"type":"extras","title":"Endpoints - JSON API","doc":"* [Get Access Points](#get-access-points)\n* [Configure SSID Priority](#configure-ssid-priority)\n* [Configure an SSID](#configure-an-ssid)\n* [Delete an SSID configuration](#delete-an-ssid-configuration)\n* [Get Configurations](#get-configurations)\n* [Get Configuration Status](#get-configuration-status)\n* [Apply](#apply)\n* [Complete the Configuration Process](#complete-the-configuration-process)\n\n#","ref":"json-api.html#endpoints"},{"type":"extras","title":"Get access points - JSON API","doc":"This request returns a list of known access points and their properties. Hidden\naccess points are not returned.\n\nPath: `/api/v1/access_points`\n\nMethod: `GET`\n\nResponse: Array AccessPoint\n\nResponse Code: `200`\n\n##","ref":"json-api.html#get-access-points"},{"type":"extras","title":"Response - JSON API","doc":"```json\n[\n  {\n    \"ssid\": \"Free WiFi!\",\n    \"frequency\": 2437,\n    \"band\": \"wifi_2_4_ghz\",\n    \"channel\": 6,\n    \"flags\": [\"ess\"],\n    \"signal_percent\": 100,\n\n  },\n  {\n    \"ssid\": \"Imperial Star Destroyer\",\n    \"frequency\": 5755,\n    \"band\": \"wifi_5_ghz\",\n    \"channel\": 151,\n    \"flags\": [\"wpa2_psk_ccmp\", \"ess\"],\n    \"signal_percent\": 75\n  }\n]\n```\n\n#","ref":"json-api.html#response"},{"type":"extras","title":"Configure SSID priority - JSON API","doc":"This endpoint takes a list of SSIDs. Each SSID is tried in order until a\nsuccessful connection is made. It is not required to list all configured SSIDs.\n\nPath: `/api/v1/ssids`\n\nMethod: `PUT`\n\nRequest: `Array String`\n\nResponse: Empty\n\nResponse Code: `204`\n\n#","ref":"json-api.html#configure-ssid-priority"},{"type":"extras","title":"Example - JSON API","doc":"##","ref":"json-api.html#example"},{"type":"extras","title":"Request - JSON API","doc":"```json\n[\n  \"Millennium Falcon\",\n  \"Death Star\",\n  \"TIE-fighter-01\",\n  \"lukes-lightsaber\"\n]\n```\n\n#","ref":"json-api.html#request"},{"type":"extras","title":"Configure an SSID - JSON API","doc":"Set connection parameters for an `SSID`.\n\nPath: `/api/v1/ /configuration`\n\nMethod: `PUT`\n\nRequest: `WiFiConfiguration`\n\nResponse: Empty\n\nResponse Code: `204`\n\n#","ref":"json-api.html#configure-an-ssid"},{"type":"extras","title":"Example - JSON API","doc":"##","ref":"json-api.html#example"},{"type":"extras","title":"Request - JSON API","doc":"`/api/v1/millennium-falcon/configuration`\n\n```json\n{\n  \"key_mgmt\": \"wpa_psk\",\n  \"password\": \"Chewbacca\"\n}\n```\n\n##","ref":"json-api.html#request"},{"type":"extras","title":"Errors - JSON API","doc":"If the configuration is passed is invalid the endpoint will return with a `400`\nstatus with one of the below errors:\n\n```json\n{\n  \"error\": \"password_required\",\n  \"message\": \"A password is required for wpa_psk access points.\"\n}\n```\n\nIf the configuration is provide a `key_mgmt` field and there is no provided\npassword.\n\n```json\n{\n \"error\": \"password_too_short\",\n \"message\": \"The minimum length for a password is 8.\"\n}\n```\n\nIf the password is less than `8` characters long as outlined in the\nIEEE Std 802.11i-2004 specification.\n\n```json\n{\n  \"error\": \"invalid_characters\",\n  \"message\": \"The password provided has invalid characters.\"\n}\n```\n\nIf the password contains characters that are not valid ASCII.\n\n```json\n{\n  \"error\": \"password_too_long\",\n  \"message\": \"The maximum length for a password is 63.\"\n}\n```\n\nIf the password is greater than `63` characters long as outlined in the\nIEEE Std 802.11i-2004 specification.\n\n#","ref":"json-api.html#errors"},{"type":"extras","title":"Delete an SSID configuration - JSON API","doc":"Delete the configuration attached to an SSID\n\nPath: `/api/v1/ /configuration`\n\nMethod: `DELETE`\n\nRequest: Empty\n\nResponse: Empty\n\nResponse Code: `200`\n\n#","ref":"json-api.html#delete-an-ssid-configuration"},{"type":"extras","title":"Get configurations - JSON API","doc":"Get the current known configurations.\n\nPath: `/api/v1/configurations`\n\nMethod: `GET`\n\nRequest: Empty\n\nResponse: `Array WiFiConfiguration` - Passwords are filtered\n\nResponse Code: 200\n\n##","ref":"json-api.html#get-configurations"},{"type":"extras","title":"Request - JSON API","doc":"```json\n[\n  {\n    \"ssid\": \"Millennium Falcon\",\n    \"key_mgmt\": \"wpa_psk\"\n  }\n]\n```\n\n#","ref":"json-api.html#request"},{"type":"extras","title":"Get configuration status - JSON API","doc":"Get the current status of the configuration. This is useful after using\nthe `/api/v1/apply` endpoint to figure out if the configurations that\nwere provided work or not.\n\nPath: `/api/v1/configuration/status`\n\nMethod: `GET`\n\nRequest: Empty\n\nResponse: `ConfigurationStatus`\n\nResponse Code: 200\n\n#","ref":"json-api.html#get-configuration-status"},{"type":"extras","title":"Apply - JSON API","doc":"A POST to this endpoint applies the configuration and attempts to connect to the\nconfigured WiFi networks. This will return back to AP mode and you can use the\n`/api/v1/configuration/status` endpoint to get whether or not the configuration\nworked or not.\n\nPath: `/api/v1/apply`\n\nMethod: `POST`\n\nRequest: Empty\n\nResponse: Empty\n\nResponse Code: `202`\n\n#","ref":"json-api.html#apply"},{"type":"extras","title":"Complete the configuration process - JSON API","doc":"Finalize the configuration process. This will apply the configuration and\nnot return to AP mode.\n\nPath: `/api/v1/complete`\n\nMethod: `GET`\n\nRequest: Empty\n\nResponse: Empty\n\nResponse Code: `202`","ref":"json-api.html#complete-the-configuration-process"},{"type":"extras","title":"Types - JSON API","doc":"#","ref":"json-api.html#types"},{"type":"extras","title":"AccessPoint - JSON API","doc":"```s\n{\n  \"ssid\": String,\n  \"signal_percent\": 0..100,\n  \"frequency\": Integer,\n  \"band\": Band,\n  \"channel\": Integer,\n  \"flags\": Flags\n}\n```\n\n#","ref":"json-api.html#accesspoint"},{"type":"extras","title":"Band - JSON API","doc":"This is the WiFi radio band that the access point is using.\n\n```s\n\"wifi_2_4_ghz\"\n\"wifi_5_ghz\"\n\"unknown\"\n```\n\n#","ref":"json-api.html#band"},{"type":"extras","title":"Flags - JSON API","doc":"Flags are reported by access points. They can be used to know whether a password\nis required to join the network. Example flags are `\"wpa2\"`, `\"psk\"`, and\n`\"eap\"`. Flags are documented in the [`vintage_net_wifi`\ndocumentation](https://hexdocs.pm/vintage_net_wifi/VintageNetWiFi.AccessPoint.html)\n\n#","ref":"json-api.html#flags"},{"type":"extras","title":"KeyManagement - JSON API","doc":"Key management is an interpretation of the `Flags` that determines what\ninformation that the user needs to provide to connect to the access point.  For\nhidden access points where the `Flags` are unavailable, the user will need to\npick one of these.\n\n```s\n\"none\" - No security\n\"wpa_psk\" - WPA or WPA2 with a pre-shared key\n\"wpa_eap\" - WPA or WPA2 with a username and password\n```\n\n#","ref":"json-api.html#keymanagement"},{"type":"extras","title":"WiFiConfiguration - JSON API","doc":"This specifies how to connect to one WiFi access point. The `ssid` and\n`key_mgmt` fields are required. Depending on the `key_mgmt`, `password` may be\nneeded.\n\n```s\n{\n  \"ssid\": String,\n  \"key_mgmt\": KeyManagement,\n  \"password\": Optional String\n}\n```\n\n#","ref":"json-api.html#wificonfiguration"},{"type":"extras","title":"ConfigurationStatus - JSON API","doc":"```s\nnot_configured - No configuration attempts have taken place\ngood - A configuration was applied and is working\nbad - A configuration was applied and is not working\n```","ref":"json-api.html#configurationstatus"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.4.15 - 2023-07-19 - Changelog","doc":"* Changed\n  * Update to support Elixir 1.15.4 and OTP 26.","ref":"changelog.html#v0-4-15-2023-07-19"},{"type":"extras","title":"v0.4.14 - 2023-05-26 - Changelog","doc":"* Changed\n  * Ignore result when terminating WatchDog GenServer to avoid an extraneous\n    crash.","ref":"changelog.html#v0-4-14-2023-05-26"},{"type":"extras","title":"v0.4.13 - 2023-05-15 - Changelog","doc":"* Changed\n  * Support changing the IP subnet used by the wizard. This lets you set it to\n    something less likely to be seen than 192.168.0.0/24. See PR #318.","ref":"changelog.html#v0-4-13-2023-05-15"},{"type":"extras","title":"v0.4.12 - 2023-01-20 - Changelog","doc":"* Changed\n  * Update to allow `:vintage_net` `v0.13.0`","ref":"changelog.html#v0-4-12-2023-01-20"},{"type":"extras","title":"v0.4.11 - 2023-01-11 - Changelog","doc":"* Changed\n  * Fixed issue preventing hidden WiFi access points from working. (@jfcloutier)","ref":"changelog.html#v0-4-11-2023-01-11"},{"type":"extras","title":"v0.4.10 - 2022-07-28 - Changelog","doc":"* Changed\n  * Support WiFi modules that expose two WiFi interfaces - one intended for\n    station mode and one intended for AP mode. This allows network connectivity\n    to be checked while using the wizard. (@jfcloutier)","ref":"changelog.html#v0-4-10-2022-07-28"},{"type":"extras","title":"v0.4.9 - 2022-05-04 - Changelog","doc":"* Changed\n  * Update to allow `:vintage_net` `v0.12.0`","ref":"changelog.html#v0-4-9-2022-05-04"},{"type":"extras","title":"v0.4.8 - 2022-04-29 - Changelog","doc":"* Added\n  * Pass `:infinity` to the `:inactivity_timeout` option to keep the wizard\n    running indefinitely regardless of user activity (@ConnorRigby)\n\n* Fixed\n  * Avoid overwriting connection details on shutdown (@paulanthonywilson)\n  * Issue when connecting to WPA2/3 networks due to deciding authentication\n    needs based on the composite set flags supplied by the wpa_supplicant","ref":"changelog.html#v0-4-8-2022-04-29"},{"type":"extras","title":"v0.4.7 - 2022-03-23 - Changelog","doc":"* Fixed\n  * `VintageNetWizard.Backend.Default` reset callback implementation\n    (@jeanparpaillon)","ref":"changelog.html#v0-4-7-2022-03-23"},{"type":"extras","title":"v0.4.6 - 2021-08-20 - Changelog","doc":"* Changed\n  * Support `:phoenix_html` `~> 2.13 or ~> 3.0`. The `v0.4.5` release removed\n    support for `~> 2.13`, but it turns out that not everyone has updated and\n    `vintage_net_wizard` works with both.","ref":"changelog.html#v0-4-6-2021-08-20"},{"type":"extras","title":"v0.4.5 - 2021-08-20 - Changelog","doc":"* Added\n  * Support for WPA3/WPA2 transitional networks. The connection still uses WPA2\n    even if WPA3 is supported by the WiFi module.","ref":"changelog.html#v0-4-5-2021-08-20"},{"type":"extras","title":"v0.4.4 - Changelog","doc":"* Fixes\n  * Fixed an issue that prevented the wizard from timing out due to inactivity. See PR #217.","ref":"changelog.html#v0-4-4"},{"type":"extras","title":"v0.4.3 - Changelog","doc":"* Enhancements\n  * Improve mobile experience. Thanks to Ole Michaelis for this update.","ref":"changelog.html#v0-4-3"},{"type":"extras","title":"v0.4.2 - Changelog","doc":"* Bug Fixes\n  * Fix a runtime error on the apply page.\n  * Fix \"undefined\" as the wizard name during application of configuration in the\n    dynamic content.","ref":"changelog.html#v0-4-2"},{"type":"extras","title":"v0.4.1 - Changelog","doc":"* Enhancements\n  * Can add some custom branding to the UI such as page title, title color, and\n    button color.\n  * Will display pre-existing configurations on the configuration page.\n  * Update example app to use `nerves_pack` and updated nerves systems.\n\n* Bug Fixes\n  * Fix a bug where starting `VintageNetWizard` would delete any pre-existing\n    configurations.","ref":"changelog.html#v0-4-1"},{"type":"extras","title":"v0.4.0 - Changelog","doc":"This release has several changes to UI text to reduce jargon and make some\nelements configurable. In particular, the title and footer are now configurable.\nGiven the breadth of styling and UI updates that have been proposed, it is\nlikely for the configuration mechanism to change again.\n\n* New features\n  * The title for the UI was changed from \"VintageNetWizard\" to \"WiFi Setup Wizard\".\n  * The footer is now empty by default. See `WizardExample.Button` for how to\n    replicate the previous information in your project.\n  * An idle timer will now exit the wizard on inactivity. The default inactivity\n    timeout is 10 minutes. This prevents accidental button presses, etc. from\n    entering the wizard and remaining there forever.","ref":"changelog.html#v0-4-0"},{"type":"extras","title":"v0.3.0 - Changelog","doc":"This release has modifications to support `vintage_net v0.9.1`. It contains no\nfunctional changes.","ref":"changelog.html#v0-3-0"},{"type":"extras","title":"v0.2.4 - Changelog","doc":"This release is mostly documentation updates and code refactoring without any\ncore usage changes. It also updates dependencies, including `vintage_net_wifi`\nto allow `vintage_net v0.8` if desired.","ref":"changelog.html#v0-2-4"},{"type":"extras","title":"v0.2.3 - Changelog","doc":"* Enhancements\n  * Support disabling captive portal","ref":"changelog.html#v0-2-3"},{"type":"extras","title":"v0.2.2 - Changelog","doc":"* New Features\n  * Support captive portal detection (thanks to @jmerriweather!)\n\n* Bug Fixes\n  * Fix adding a network not shown in the AP list\n\n* Enhancements\n  * Include the configuration status on the webpage\n  * Allow submitting the configuration without verifying it. (Useful when you want to configure networks that aren't nearby or confident the config is good)\n  * Better message page when configuration verification is running\n  * Better message when configuration fails\n  * Show WPA Enterprise option when adding a network not in the AP list","ref":"changelog.html#v0-2-2"},{"type":"extras","title":"v0.2.1 - Changelog","doc":"Some fun doc updates and type fixes.\n\n* Enhancements\n  * Don't require internet connectivity to consider a WiFi config as successful","ref":"changelog.html#v0-2-1"},{"type":"extras","title":"v0.2.0 - Changelog","doc":"This release contains updates to use `vintage_net` `v0.7.0`. This includes\ndepending on `vintage_net_wifi` and renaming keys used for the configuration.\nProjects pulling this update should review the [`vintage_net` release\nnotes](https://github.com/nerves-networking/vintage_net/releases/tag/v0.7.0).\n\n* New features\n  * Support customization of the SSID. In your `config.exs`, add the following:\n\n```\nconfig :vintage_net_wizard,\n      ssid: \"MY_SSID\"\n```","ref":"changelog.html#v0-2-0"},{"type":"extras","title":"v0.1.7 - Changelog","doc":"* New features\n  * Added `VintageNetWizard.stop_wizard/0`\n  * Added a callback so that users could be notified when configuration\n    completes","ref":"changelog.html#v0-1-7"},{"type":"extras","title":"v0.1.6 - Changelog","doc":"* New features\n  * Added support for configuring WPA-EAP PEAP\n\n* Bug fixes\n  * Fixed issue where the UI would ask for a password for some access points\n    that didn't have security.","ref":"changelog.html#v0-1-6"},{"type":"extras","title":"v0.1.5 - Changelog","doc":"* Bug fixes\n  * Fixed error when not using SSL\n  * Don't create invalid SSIDs if the hostname isn't set or is something really\n    long","ref":"changelog.html#v0-1-5"},{"type":"extras","title":"v0.1.4 - Changelog","doc":"* Improvements\n  * Better handle using Erlang `:ssl` options when starting the wizard","ref":"changelog.html#v0-1-4"},{"type":"extras","title":"v0.1.3 - Changelog","doc":"* Improvements\n  * Add dnsd to reduce connection time and allow users to connect via DNS names\n    (mDNS was also possible, but not as likely to work everywhere)","ref":"changelog.html#v0-1-3"},{"type":"extras","title":"v0.1.2 - Changelog","doc":"* Improvements\n  * Actively update WiFi networks in the UI\n  * Validate WPA passphrases\n\n* Bug fixes\n  * AP mode configuration is no longer persisted. If a device is rebooted when\n    running the wizard, it will start with the previous configuration.\n  * Fix SSL certificate paths","ref":"changelog.html#v0-1-2"},{"type":"extras","title":"v0.1.1 - Changelog","doc":"* Improvements\n  * Developer must now explicitly start the wizard server to place device into\n    AP mode. This prevents the device from starting up automatically in\n    and unwanted state.","ref":"changelog.html#v0-1-1"},{"type":"extras","title":"v0.1.0 - Changelog","doc":"Initial release","ref":"changelog.html#v0-1-0"}],"content_type":"text/markdown"}